// stm8s103f3_loader.cs
using System;
using System.IO;
using System.IO.Ports;
using System.Threading;
using System.Collections.Generic;

public class STM8uLoader
{
	
	public static void Main(string[] arg)   { 
		if (arg.Length == 0) {Console.WriteLine("Отсутствуют аргументы командной строки"); 
								Console.ReadKey(); return;}
		else fileName = arg[0];
		Console.WriteLine("Обнаружены {0} аргумент(ов) командной строки", arg.Length);
		foreach(string strArg in arg){
			Console.WriteLine(strArg);
		}//foreach
			
		FileOpenMemorySorting fileSorted = new FileOpenMemorySorting(fileName);

		Console.Write("Из файла");
			foreach( KeyValuePair<int, byte[]> kvp in fileSorted.GetRAMaddressLineSorted() ){
				Console.Write("\n ${0:X4} ", kvp.Key);
				for(int i = 0; i < kvp.Value.Length; i++) Console.Write("${0:X2} ", kvp.Value[i]);
			}// foreach

		Console.WriteLine("\n");

		

		//Dumps	myDumps = new Dumps();

		Dumps.COM_port_Open();
		readThread = new Thread(Dumps.Read);
		readThread.IsBackground = true; // не позволит остаться потоку в памяти после закрытия программы ?
			try {
				readThread.Start();		// запускаем поток чтения COM порта
			} catch (Exception ex) {Console.WriteLine(" readThread.Start(). Exception" + ex.Message); } 
					
		Dumps.Load_First_Dump(Dumps.Read_128000v14);

		blckAdr = 0x0100;	blckSize = 178;
		Console.WriteLine("  Из памяти до записи");
		Dumps.Dump_To_Console(Dumps.Read_128000(blckAdr, blckSize));

		//Dumps.Load_Dump(Dumps.Wtite_RAM_128000v14);
		Console.WriteLine("  пишем в память");
		Dumps.Write_RAM_128000(fileSorted.GetRAMaddressLineSorted());
		
		//Dumps.Load_Dump(Dumps.Read_128000v14);

		blckAdr = 0x0100;	blckSize = 178;
		Console.WriteLine("  Из памяти после записи");
		Dumps.Dump_To_Console(Dumps.Read_128000(blckAdr, blckSize));
		
		//Dumps.Load_Dump(Dumps.Copy_RAM_128000v14);
		
		Console.WriteLine("  Копируем из EEPROM в RAM");
		Dumps.Copy_RAM_128000(0x0100, 0x4000, 255);
		
		//Dumps.Load_Dump(Dumps.Read_128000v14);

		blckAdr = 0x4000;	blckSize = 255;
		Console.WriteLine("  Из EEPROM");
		Dumps.Dump_To_Console(Dumps.Read_128000(blckAdr, blckSize));
		
		blckAdr = 0x0100;	blckSize = 255;
		Console.WriteLine("  Из памяти после копирования");
		Dumps.Dump_To_Console(Dumps.Read_128000(blckAdr, blckSize));
		
		readThread.Join();	// останавливаем поток чтения COM порта
		Dumps.COM_port_Close();
		Console.ReadKey(); return;
    } // Main();
    public static Thread readThread;

	public static string stringMemoryMap = "";
	public  static byte rx_byte = 0x00;
	public static byte[] btBytes = new byte[1];
	public static byte[] wrd4Bytes = new byte[4];
	public static byte[] blck64Bytes = new byte[64];
	public static int blckAdr;
	public static int blckSize;
	public  static bool unready = true;
	public  static string fileName;	
	public static byte[] txBytes = {0, 0};

}// class STM8uLoader
// STM8uLoader.cs